<?php
/*
PrimePayments - Удобный сервис платежей для вашего бизнеса
*/
error_reporting(0);
include_once 'lib/ConfigWritter.php';
include_once 'lib/Model.php';


class Handler
{
    function process()
    {
        try {
            $model = Model::getInstance();
            $config = ConfigWritter::getInstance();

            if (empty($_REQUEST)) {
                header('Content-Type: text/html; charset=utf-8');
                die ('Адрес данного скрипта нужно прописать в поле "URL скрипта обработчика" в настройках вашего проекта');
            }
            if (!$_REQUEST['sign']) {
                throw new Exception("Некорректный запрос");
            }
            if (!isset($_REQUEST['innerID']) || !isset($_REQUEST['sum']) || !isset($_REQUEST['sign'])) {
                throw new Exception('Отсутствуют обязательные параметры платежа');
            }
            if(!$payment = $model->getPaymentByIntid($_REQUEST['innerID'])){
                throw new Exception('Платёж не найден в базе');
            }

            if($_REQUEST['action'] == 'order_payed'){
                $checkSign = md5($config->getParameter('SECRET_KEY_2') . 
                                $_REQUEST['orderID'] . 
                                $_REQUEST['payWay'] . 
                                $_REQUEST['innerID'] . 
                                $_REQUEST['sum'] . 
                                $_REQUEST['webmaster_profit']);
                if($checkSign != $_REQUEST['sign']){
                    throw new Exception('Цифровая подпись не совпадает');
                }

                if ($payment->status == 1) {
                    return 'Платеж уже проведен';
                }

                if (!$model->confirmPaymentByIntid($_REQUEST['innerID'])) {
                    throw new Exception('Не удается подтвердить платеж в БД. Проверьте права на запись');
                }

                if (!$model->addItemToChar($payment->account, $config->getParameter('ITEM_ID'), $payment->itemsCount)) {
                    throw new Exception('Не удалось начислить персонажу требуемые вещи');
                }

                $this->responseSuccess('OK');
            }


        } catch (Exception $e) {
            $this->responseError($e->getMessage());
        }
    }

    function responseError($message) {
        echo $message; exit();
    }
    
    function responseSuccess($message) {
        echo $message; exit();
    }
}

$handler = new Handler();
$handler->process();
